Package com.pixelmed.display

## Class SpectraPanel

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - com.pixelmed.display.PlotGraph
        - - com.pixelmed.display.SpectraPanel

- All Implemented Interfaces:
    `java.awt.event.MouseListener`, `java.awt.event.MouseMotionListener`, `java.awt.image.ImageObserver`, `java.awt.MenuContainer`, `java.io.Serializable`, `java.util.EventListener`

      public class SpectraPanel
      extends PlotGraph
      implements java.awt.event.MouseListener, java.awt.event.MouseMotionListener

  Implements a component that can display a single or multi-frame spectra in a single panel, over an optional background image, with scrolling through frames of a multi-frame spectra, resizing to the size of the panel, feedback of cursor position status.

  See Also:
    `SourceSpectra`, `SourceImage`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.pixelmed.display.PlotGraph

      `PlotGraph.FloatArrayStatistics`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class com.pixelmed.display.PlotGraph

      `heightOfTile, imageOfRenderedPlot, nTilesPerColumn, nTilesPerRow, samples, samplesPerRow, samplesPerTile, statistics, widthOfTile`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SpectraPanel​(float[][] srcSpectra, int nTilesPerColumn, int nTilesPerRow, float minimum, float maximum, GeometryOfVolume spectroscopyGeometry, SpectroscopyVolumeLocalization spectroscopyVolumeLocalization, EventContext typeOfPanelEventContext, EventContext backgroundImageEventContext)` | Build a panel in which to display the supplied spectra.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `deconstruct()` |
    `static void` | `deconstructAllSpectraPanelsInContainer​(java.awt.Container container)` |
    `protected void` | `finalize()` |
    `GeometryOfVolume` | `getSpectroscopyGeometry()` | Get the geometry of the frames currently loaded in the spectroscopy panel.
    `SpectroscopyVolumeLocalization` | `getSpectroscopyVolumeLocalization()` | Get the localization volume of the spectra currently loaded in the spectroscopy panel.
    `void` | `mouseClicked​(java.awt.event.MouseEvent e)` |
    `void` | `mouseDragged​(java.awt.event.MouseEvent e)` |
    `void` | `mouseEntered​(java.awt.event.MouseEvent e)` |
    `void` | `mouseExited​(java.awt.event.MouseEvent e)` |
    `void` | `mouseMoved​(java.awt.event.MouseEvent e)` |
    `void` | `mousePressed​(java.awt.event.MouseEvent e)` |
    `void` | `mouseReleased​(java.awt.event.MouseEvent e)` |
    `void` | `paintComponent​(java.awt.Graphics g)` |

    - ### Methods inherited from class com.pixelmed.display.PlotGraph

      `actuallyPaintComponent, main`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getUI, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update, updateUI`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, list, list, paintComponents, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAccessibleContext, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, hasFocus, imageUpdate, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, list, list, list, paintAll, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### SpectraPanel

          public SpectraPanel​(float[][] srcSpectra,
                              int nTilesPerColumn,
                              int nTilesPerRow,
                              float minimum,
                              float maximum,
                              GeometryOfVolume spectroscopyGeometry,
                              SpectroscopyVolumeLocalization spectroscopyVolumeLocalization,
                              EventContext typeOfPanelEventContext,
                              EventContext backgroundImageEventContext)

      Build a panel in which to display the supplied spectra.

      Parameters:
        `srcSpectra` - the spectra to display
        `nTilesPerColumn` - the number of tiles per column
        `nTilesPerRow` - the number of tiles per row
        `minimum` - the minimum data value to display (bottom of a tile)
        `maximum` - the maximum data value to display (top of a tile)
        `spectroscopyGeometry` - the 3D location of the acquired spectroscopy data
        `spectroscopyVolumeLocalization` - the 3D localization performed prior to acquisition of the spectroscopy data
        `typeOfPanelEventContext` -
        `backgroundImageEventContext` -

  - ### Method Detail

    - #### getSpectroscopyGeometry

          public GeometryOfVolume getSpectroscopyGeometry()

      Get the geometry of the frames currently loaded in the spectroscopy panel.

      Returns:
        the geometry of the frames

    - #### getSpectroscopyVolumeLocalization

          public SpectroscopyVolumeLocalization getSpectroscopyVolumeLocalization()

      Get the localization volume of the spectra currently loaded in the spectroscopy panel.

      Returns:
        the localization volume

    - #### mouseClicked

          public void mouseClicked​(java.awt.event.MouseEvent e)

      Specified by:
        `mouseClicked` in interface `java.awt.event.MouseListener`
      Parameters:
        `e` -

    - #### mouseEntered

          public void mouseEntered​(java.awt.event.MouseEvent e)

      Specified by:
        `mouseEntered` in interface `java.awt.event.MouseListener`
      Parameters:
        `e` -

    - #### mouseExited

          public void mouseExited​(java.awt.event.MouseEvent e)

      Specified by:
        `mouseExited` in interface `java.awt.event.MouseListener`
      Parameters:
        `e` -

    - #### mouseDragged

          public void mouseDragged​(java.awt.event.MouseEvent e)

      Specified by:
        `mouseDragged` in interface `java.awt.event.MouseMotionListener`
      Parameters:
        `e` -

    - #### mouseMoved

          public void mouseMoved​(java.awt.event.MouseEvent e)

      Specified by:
        `mouseMoved` in interface `java.awt.event.MouseMotionListener`
      Parameters:
        `e` -

    - #### mousePressed

          public void mousePressed​(java.awt.event.MouseEvent e)

      Specified by:
        `mousePressed` in interface `java.awt.event.MouseListener`
      Parameters:
        `e` -

    - #### mouseReleased

          public void mouseReleased​(java.awt.event.MouseEvent e)

      Specified by:
        `mouseReleased` in interface `java.awt.event.MouseListener`
      Parameters:
        `e` -

    - #### paintComponent

          public void paintComponent​(java.awt.Graphics g)

      Overrides:
        `paintComponent` in class `PlotGraph`
      Parameters:
        `g` -

    - #### deconstruct

          public void deconstruct()

    - #### deconstructAllSpectraPanelsInContainer

          public static void deconstructAllSpectraPanelsInContainer​(java.awt.Container container)

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Throws:
        `java.lang.Throwable`